
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GenresDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const genres = await db.genres.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        origin: data.origin
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        typical_bpm_min: data.typical_bpm_min
        ||
        null
            ,
            
        typical_bpm_max: data.typical_bpm_max
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await genres.setParent_genre( data.parent_genre || null, {
            transaction,
        });
        
        await genres.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return genres;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const genresData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                origin: item.origin
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                typical_bpm_min: item.typical_bpm_min
            ||
            null
            ,
            
                typical_bpm_max: item.typical_bpm_max
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const genres = await db.genres.bulkCreate(genresData, { transaction });

        // For each item created, replace relation files
        

        return genres;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const genres = await db.genres.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.origin !== undefined) updatePayload.origin = data.origin;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.typical_bpm_min !== undefined) updatePayload.typical_bpm_min = data.typical_bpm_min;
        
        
        if (data.typical_bpm_max !== undefined) updatePayload.typical_bpm_max = data.typical_bpm_max;
        
        
        updatePayload.updatedById = currentUser.id;

        await genres.update(updatePayload, {transaction});

        
        
        if (data.parent_genre !== undefined) {
            await genres.setParent_genre(
              
              data.parent_genre,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await genres.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return genres;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const genres = await db.genres.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of genres) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of genres) {
                await record.destroy({transaction});
            }
        });


        return genres;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const genres = await db.genres.findByPk(id, options);

        await genres.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await genres.destroy({
            transaction
        });

        return genres;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const genres = await db.genres.findOne(
            { where },
            { transaction },
        );

        if (!genres) {
            return genres;
        }

        const output = genres.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.projects_primary_genre = await genres.getProjects_primary_genre({
            transaction
        });
        
        
        
        output.songs_genre = await genres.getSongs_genre({
            transaction
        });
        
        
        
        
        
        
        
        output.generation_requests_target_genre = await genres.getGeneration_requests_target_genre({
            transaction
        });
        
        
        output.vocal_processing_presets_recommended_genre = await genres.getVocal_processing_presets_recommended_genre({
            transaction
        });
        
        
        output.mastering_presets_genre = await genres.getMastering_presets_genre({
            transaction
        });
        
        
        
        
        
        
        output.marketplace_listings_genre = await genres.getMarketplace_listings_genre({
            transaction
        });
        
        
        
        
        output.parent_genre = await genres.getParent_genre({
            transaction
        });
        
        
        output.organizations = await genres.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.genres,
        as: 'parent_genre',
        
        where: filter.parent_genre ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent_genre.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.parent_genre.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'genres',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'genres',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.typical_bpm_minRange) {
                const [start, end] = filter.typical_bpm_minRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    typical_bpm_min: {
                    ...where.typical_bpm_min,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    typical_bpm_min: {
                    ...where.typical_bpm_min,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.typical_bpm_maxRange) {
                const [start, end] = filter.typical_bpm_maxRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    typical_bpm_max: {
                    ...where.typical_bpm_max,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    typical_bpm_max: {
                    ...where.typical_bpm_max,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.origin) {
                where = {
                    ...where,
                origin: filter.origin,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.genres.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'genres',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.genres.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

